# Tidy Perl Wrapper
#
# Wrapper generated by SWIG, see www.swig.org.
# Makefile.PL adapted from XML::Parser
# Errors introduced by Charles Reitzel

use ExtUtils::MakeMaker;
use Config;

my $libs = "-ltidy";
my $incs = "";

$tidy_libpath = '';
$tidy_incpath = '';

my @replacement_args;

foreach (@ARGV) {
  if (/^TIDY(LIB|INC)PATH=(.+)/) {
    if ($1 eq 'LIB') {
      $tidy_libpath = $2;
    }
    else {
      $tidy_incpath = $2;
    }
  }
  else {
    push(@replacement_args, $_);
  }
}

@ARGV = @replacement_args;

if (not $tidy_libpath and $] >= 5.006001) {
  require ExtUtils::Liblist;		# Buggy before this
  ($tidy_libpath) = ExtUtils::Liblist->ext('-ltidy');
}

unless ($tidy_libpath) {
  # Test for existence of libtidy
  my $found = 0;
  foreach (split(/\s+/, $Config{libpth})) {
    if (-f "$_/libtidy." . $Config{so}) {
      $found = 1;
      last;
    }
  }

  unless ($found) {
    die <<'Tidy_Not_Installed;';

Tidy must be installed prior to building Tidy and I can't find
it in the standard library directories. You can download tidy from:

http://sourceforge.net/projects/tidy/

If tidy is installed, but in a non-standard directory, then use the
following options to Makefile.PL:

    TIDYLIBPATH=...  To set the directory in which to find libtidy

    TIDYINCPATH=...  To set the directory in which to find tidy.h

For example:

    perl Makefile.PL TIDYLIBPATH=/home/me/lib TIDYINCPATH=/home/me/include

Note that if you build against a shareable library in a non-standard location
you may (on some platforms) also have to set your LD_LIBRARY_PATH environment
variable at run time for perl to find the library.

Tidy_Not_Installed;
  }
}

if ( $tidy_libpath ) {
  $libs = "-L$tidy_libpath $libs";
  $tidy_libpath .= "/";
}
if ( $tidy_incpath ) {
  $incs = "-I$tidy_incpath"
}

@extras = ();

if ( $PERL_VERSION >= 5.005 and $OSNAME eq 'MSWin32'
     and $Config{archname} =~ /-object\b/i )
{
  push( @extras, CAPI => 'TRUE')
}

if ($ExtUtils::MakeMaker::Version >= 5.4301)
{
  push( @extras,
        ABSTRACT => 'Perl wrapper for HTML Tidy library.  See http://tidy.sourceforge.net/',
        AUTHOR   => 'Charles Reitzel (creitzel@rcn.com)' );
}
     
WriteMakefile( NAME         => 'HTML::Tidy',
               DIR          => [],
               OBJECT       => 'tidyperl.obj',
               LIBS         => $libs,
               INC          => $incs,
               MYEXTLIB     => $tidy_libpath . "libtidy.lib",
               dist         => {COMPRESS => '', SUFFIX => '.tar'},
               VERSION      => '0.1',
               @extras );

