BEGIN {print "1..13\n";}
END {print "not ok 1\n" unless $loaded;}
use HTML::Tidy;
$loaded = 1;
print "ok 1\n";

################################################################
# Full Tidy Operations

sub dump_outline
{
  my ($tidy, $node, $indent) = @_;
  if ( $node )
  {
    my $name = $node->Name();
    if ( $node->IsText() ) {
      $name = "Text Node";
    }
    elsif ( ! $name ) {
      $name = "Unknown!";  # TODO: switch on node type
    }

    print OUTLINE ' ' x $indent, $name, "\n";

    for ( $node = $node->Child(); $node; $node = $node->Next() )
    {
      dump_outline( $tidy, $node, $indent + 1 );
    }
  }
  return 0;
}

my $tidy = HTML::Tidy::Document->new();
if ( $tidy ) {
  print "ok 2\n";
}
else {
  print "not ok 2\n";
}

my $stat = $tidy->Create();
if ( $stat >= 0 ) {
  print "ok 3\n";
}
else {
  print "not ok 3\n";
}

$stat = $tidy->SetErrorFile( "t/errors.txt" );
if ( $stat >= 0 ) {
  print "ok 4\n";
}
else {
  print "not ok 4\n";
}

$stat = $tidy->LoadConfig( "t/test.tidy" );
if ( $stat >= 0 ) {
  print "ok 5\n";
}
else {
  print "not ok 5\n";
}

$stat = $tidy->ParseFile( "t/dump.html" );
if ( $stat >= 0 ) {
  print "ok 6\n";
}
else {
  print "not ok 6\n";
}


$stat = $tidy->CleanAndRepair();
if ( $stat >= 0 ) {
  print "ok 7\n";
}
else {
  print "not ok 7\n";
}

$stat = $tidy->RunDiagnostics();
if ( $stat >= 0 ) {
  print "ok 8\n";
}
else {
  print "not ok 8\n";
}

open( OUTLINE, ">t/dump.outline.txt" )
  or die( "Error opening dump.outline.txt: $!" );

my $node = $tidy->GetRoot();
$stat = dump_outline( $tidy, $node, 0 );
if ( $stat >= 0 ) {
  print "ok 9\n";
}
else {
  print "not ok 9\n";
}

close( OUTLINE );

$stat = ( $tidy->OptSetBool(HTML::Tidy::TidyForceOutput, 1) ? 0 : -1 );
if ( $stat >= 0 ) {
  print "ok 10\n";
}
else {
  print "not ok 10\n";
}

my $out = '';
($stat, $out) = $tidy->SaveString(); # "t/dump.tidied.html" );
if ( $stat >= 0 ) {
  print "ok 11\n";
}
else {
  print "not ok 11\n";
}

if ( length($out) > 0 ) {
  print "ok 12\n";
}
else {
  print "not ok 12\n";
}

$tidy->Release();
print "ok 13\n";
